import java.awt.geom.Line2D;
import java.util.ArrayList;

/**
 * Die Klasse Kante repraesentiert Kanten in einem Graphen.
 * Sie stellt auch Methoden zur Verwaltung aller Kanten bereit.
 * 
 * @author (claus albowski) 
 * @version (dez 06)
 */
public class Kante
extends Line2D.Double
implements Comparable  // ermoeglicht das automatische Sortieren mit sort()
{
    // Klassenvariable
    private static ArrayList<Kante> kantenListe = new ArrayList<Kante>();
    private static int x=300;
    private static int y=300;
    // Klassenmethode
    public static void setzeDimension(int breite, int hoehe){ x=breite;y=hoehe; }
    private static void neueKante(Kante k){ kantenListe.add(k); }
    public static ArrayList<Kante> gibKanten(){ return kantenListe; }
    public static Kante gibKante(int i){ return kantenListe.get(i); }
    public static int gibAnzahl() { return kantenListe.size(); }
    public static void loescheKanten(){
        while (! kantenListe.isEmpty()) kantenListe.get(0).entferneKante();
    }
    
    // Fuer das Interface  Comparable notwendige Methode:
    public int compareTo(Object k) {
        if (laenge()<((Kante)k).laenge()) return -1;
        else if (laenge()>((Kante)k).laenge()) return 1;
        else return 0;
    }
    
    // Instanzvariable
    private Knoten p1,p2;
    
    /**
     * Konstruktor fuer Objekte der Klasse Kante
     */
    public Kante(Knoten p1, Knoten p2){
        super(p1, p2);
        this.p1=p1;
        this.p2=p2;
        p1.neueKante(this);
        p2.neueKante(this);
        neueKante(this);
    }
    
    public Knoten gibP1() { return p1; }
    public Knoten gibP2() { return p2; }
    
    /**
     * entfernt diese Kante aus der Kantenliste.
     */
    public void entferneKante(){
        p1.entferneKante(this);
        p2.entferneKante(this);
        kantenListe.remove(this);
    }

    /**
     * gibt den anderen Knoten der Kante zurueck.
     */
    public Knoten andererKnoten(Knoten p){
        if (p.equals(p1)) return p2;
        if (p.equals(p2)) return p1;
        return null;
    }
    
    /**
     * gibt die Laenge der Kante  zurueck.
     */
    public double laenge(){
        return p1.distance(p2);
    }

    /**
     * zeichnet diese Kante auf den Bildschirm.
     */
    public void zeichne(String farbe)
    {
        Leinwand leinwand = Leinwand.gibLeinwand();
        leinwand.zeichne (
          this,          // leinwand kennt das Objekt
          farbe,         // definiert seine Zeichenfarbe
          this);         // definiert seinen grafischen Aspekt
    }
}
